<?php
/*
original file name   : mybitskins.class.php
begin                : October 1 2005
copyright            : (C) 2005 Olivier D. alias ze kat
email                : oliezekat@yahoofr
web					 : www.yahooplus.fr.st

This program is free software; you can redistribute it and/or modify  	
it under the terms of the GNU General Public License as published by  
the Free Software Foundation; either version 2 of the License, or	    	
(at your option) any later version.

AUTHORS:
Olivier D. alias ze kat :	oliezekat@yahoo.fr	since October 1 2005

LAST CHANGES:
(most recents at end)
 - Add 'items_limit_per_source' option while open several sources
 - Optimized while open several sources (or with 'GetFromRoot'
   method). Use 'items_limit_per_source' option instead of 
   'items_limit' for each source.

*/

// Global constants
	// URLs des copyrights
	define('_MYBS_YMESSENGERPLUS_URL','http://www.yahooplus.fr.st/');

class mYBitSkins
	{
	// Public properties
		var $cache_dir = '';
		var $cache_time = 14400; 	// Keep cache file during 4 hours
		var $cache_all = FALSE; 	// Set TRUE if you make several differents Get(array(...)) with some common sources 
		var $order_by = '';			// Set with 'date' to sort by last modified date (most recent first)
									// Set with 'name' to sort by display name
		var $items_limit = 0;
		var $items_limit_per_source = 0;
		
	// Private properties
		// Tableau avec les noms de fichiers/dossiers  ignorer
		var $_FILES_TO_IGNORE = array();
		var $_FOLDERS_TO_IGNORE = array('cache','admin','rss');
		// Tableau avec les types de skins autoriss
		var $_ALLOWED_EXTENSIONS = array('ysz','yms','zip','exe'); // YMS is old skins for Messenger 5.x, don't merge skins 5.x and 6 in same folder
		var $_ALLOWED_PREVIEW_EXTENSIONS = array('jpg','gif','png','jpeg');
		var $_MIMES_TYPES = array(	'ysz'	=>	'interface/x-ypager-bskin',
									'yms'	=>	'interface/x-ypager-skin',
									'zip'	=>	'application/x-zip-compressed',
									'exe'	=>	'application/x-msdownload',
									'gif'	=>	'application/x-msdownload',
									'jpg'	=>	'application/x-msdownload',
									'jpeg'	=>	'application/x-msdownload',
									'png'	=>	'application/x-msdownload'
									);
		var $_XML_SKIN_ATTRIBUTES = array('version','AuthorName','AuthorURL','AuthorEmail','AuthorID','AuthorFeed','SkinFolder','SkinName');
		var $_XML_DEF_NAMES = array('standard','ymsgr','ymesection','overlapped_tabs','bttlphui');
		
		var $_USE_SEVERAL_SOURCES = FALSE;
		var $_STARTED_INDEX = 0;
	
	//Public methods
	
	function Get($rootPath='./',$rootURL='./',$subFolder='')
		// One source : Get('./','','');
		// Several sources : Get($sourceArray);
		// with $sourceArray = array ( array('./root1/','','folderA'), array(...), array(...), ...);
		// Future feature with $rootPath equal URL (or array of URLs) to mRSS feed created with mYBitSkins
		{
		$this->_USE_SEVERAL_SOURCES = FALSE;
		$this->_STARTED_INDEX = 0;
		
		if (is_array($rootPath) == TRUE)
			{
			// Use several sources... Future feature
			if (sizeof($rootPath) == 1)
				{
				return $this->GetFromOneSource($rootPath[0][0],$rootPath[0][1],$rootPath[0][2]);
				}
			else
				{
				return $this->GetFromSeveralSources($rootPath);
				}
			}
		else
			{
			return $this->GetFromOneSource($rootPath,$rootURL,$subFolder);
			}
		}
		
	function GetFromRoot($rootPath='./',$rootURL='./')
		// Search sub-folders (not recursively) with skins from local path. Include skins from root too.
		{
		if (substr($rootPath, -1) != '/')
			{
			$rootPath .= '/';
			}
		$sourcesArray[0][0] = $rootPath;
		$sourcesArray[0][1] = $rootURL;
		$sourcesArray[0][2] = '';
		
		$i = 1;
		$rep = opendir($rootPath);
		while ($subFolder = readdir($rep))
			{
			if (($subFolder != '..') && ($subFolder !='.') && ($subFolder !='') && (is_dir($rootPath.$subFolder)))
				{
				if (in_array($subFolder,$this->_FOLDERS_TO_IGNORE))
					{
					
					}
				else
					{
					$sourcesArray[$i][0] = $rootPath;
					$sourcesArray[$i][1] = $rootURL;
					$sourcesArray[$i][2] = $subFolder;
					
					$i++;
					}
				}
			}
		closedir($rep);
		clearstatcache();
		
		return $this->Get($sourcesArray);
		}
	
	//Private methods
	
	function GetFromOneSource($rootPath='./',$rootURL='./',$subFolder='')
		// Future feature: $rootPath equal URL to mRSS feed created with mYBitSkins
		{
		return $this->GetFromLocal($rootPath,$rootURL,$subFolder);
		}
		
	function GetFromSeveralSources($sourcesArray)
		{
		if ($this->cache_dir != '')
			{
			// If CACHE ENABLED
			$cache_file = $this->cache_dir.'/mybs_huge_cache_'.md5(serialize($sourcesArray)."?s=".$this->order_by."&l=".$this->items_limit);
			if (file_exists($cache_file))
				{
				$timedif = @(time() - filemtime($cache_file));
				}
			else
				{
				$timedif = $this->cache_time;
				}
			if ($timedif < $this->cache_time)
				{
				// cached file is fresh enough, return cached array
				$result = unserialize(join('', file($cache_file)));
				// set 'cached' to 1 only if cached file is correct
				if ($result) $result['Cached'] = 1;
				}
			else
				{
				// cached file is too old, create new
				$result = $this->ParseFromSeveralSources($sourcesArray);
				
				$serialized = serialize($result);
				if ($f = @fopen($cache_file, 'w'))
					{
					fwrite ($f, $serialized, strlen($serialized));
					fclose($f);
					}
				if ($result) $result['Cached'] = 0;
				}
			}
		else
			{
			$result = $this->ParseFromSeveralSources($sourcesArray);
			$result['Cached'] = 0;
			}

		return $result;
		}
	
	function GetFromLocal($rootPath='./',$rootURL='',$subFolder='')
		{
		/**
		* Original cache feature from lastRSS project under GNU-GPL
		* http://lastrss.webdot.cz/
		*/
		if (substr($rootPath, -1) != '/')
			{
			$rootPath .= '/';
			}
			
		if ($this->cache_dir != '')
			{
			// If CACHE ENABLED
			if ($subFolder != '')
				{
				$realSourcePath = realpath($rootPath.'/'.$subFolder.'/');
				}
			else
				{
				$realSourcePath = realpath($rootPath);
				}
			$cache_file = $this->cache_dir.'/mybs_local_cache_'.md5($realSourcePath."?s=".$this->order_by."&l=".$this->items_limit);
			if (file_exists($cache_file))
				{
				$timedif = @(time() - filemtime($cache_file));
				}
			else
				{
				$timedif = $this->cache_time;
				}
			if ($timedif < $this->cache_time)
				{
				// cached file is fresh enough, return cached array
				$result = unserialize(join('', file($cache_file)));
				// set 'cached' to 1 only if cached file is correct
				if ($result) $result['Cached'] = 1;
				}
			else
				{
				// cached file is too old, create new
				$result = $this->ParseFromLocal($rootPath,$rootURL,$subFolder);
				if (($this->_USE_SEVERAL_SOURCES) AND ($this->cache_all == FALSE))
					{
					
					}
				else
					{
					$serialized = serialize($result);
					if ($f = @fopen($cache_file, 'w'))
						{
						fwrite ($f, $serialized, strlen($serialized));
						fclose($f);
						}
					}
				if ($result) $result['Cached'] = 0;
				}
			}
		else
			{
			// If CACHE DISABLED >> load and parse the file directly
			$result = $this->ParseFromLocal($rootPath,$rootURL,$subFolder);
			if ($result) $result['Cached'] = 0;
			}
		// return result
		return $result;
		}
		
	function ParseFromSeveralSources($sourcesArray)
		{
		$this->_USE_SEVERAL_SOURCES = TRUE;
		$_ALL_SOURCES_ITEMS_LIMIT = $this->items_limit;
		$this->items_limit = $this->items_limit_per_source;
		
		$result['skins'] = array(); // create array even if there are no skins
		foreach($sourcesArray as $sourceArray)
			{
			$oneresult = $this->GetFromOneSource($sourceArray[0],$sourceArray[1],$sourceArray[2]);
			$result['skins'] = array_merge($result['skins'],$oneresult['skins']);
			}
			
		$this->items_limit = $_ALL_SOURCES_ITEMS_LIMIT;
		
		if (($this->order_by == 'name') AND ($this->_STARTED_INDEX > 0))
			{
			uasort($result['skins'],mYBS_CompareSkinsName);
			}
			
		if (($this->order_by == 'date') AND ($this->_STARTED_INDEX > 0))
			{
			uasort($result['skins'],mYBS_CompareSkinsMTime);
			}
			
		if (($this->items_limit != 0) AND ($this->_STARTED_INDEX > $this->items_limit))
			{
			$this->ArrayPop($result['skins'],$this->items_limit);
			}
		
		$result['severalSources'] = TRUE;
		
		// return result
		return $result;
		}
	
	function ParseFromLocal($rootPath='./',$rootURL='',$subFolder='')
		{
		$result['localSource'] = TRUE;
		$result['rootPath'] = $rootPath;
		if (substr($result['rootPath'], -1) != '/')
			{
			$result['rootPath'] .= '/';
			}
		$result['sourcePath'] = $result['rootPath'];
		$result['rootURL'] = $rootURL;
		if (substr($result['rootURL'], -1) != '/')
			{
			$result['rootURL'] .= '/';
			}
		$result['sourceURL'] = $result['rootURL'];
		if ($subFolder != '')
			{
			$result['subFolder'] = $subFolder;
			$result['sourcePath'] .= $result['subFolder'].'/';
			$result['sourceURL'] .= $result['subFolder'].'/';
			}
		$result['realSourcePath'] = realpath($result['sourcePath']);
		
		$result['skins'] = array(); // create array even if there are no skins
		$i = 0;
		$rep = opendir($result['sourcePath']);
		while ($file = readdir($rep))
			{
			if (($file != '..') && ($file !='.') && ($file !=''))
				{
				//Informations sur le fichier
				$fileinfos = pathinfo($file);
				
				if (is_dir($result['sourcePath'].$file) OR empty($fileinfos['extension']) OR (in_array($file,$this->_FILES_TO_IGNORE)))
					{
					//Dossier ou fichier  ignorer
					}
				else if (in_array(strtolower($fileinfos['extension']),$this->_ALLOWED_EXTENSIONS))
					{
					// Index unique associ au skin
					$kidx = md5($result['sourceURL'].$fileinfos['basename']);
						
					$result['skins'][$kidx]['sourcePath'] = $result['sourcePath'];
					$result['skins'][$kidx]['sourceURL'] = $result['sourceURL'];
					$result['skins'][$kidx]['subFolder'] = $result['subFolder'];
					
					$result['skins'][$kidx]['baseName'] = $fileinfos['basename'];
					$result['skins'][$kidx]['fileName'] = substr($fileinfos['basename'],0,strlen($fileinfos['basename'])-strlen($fileinfos['extension'])-1);
					$result['skins'][$kidx]['fileExtension'] = $fileinfos['extension'];
					$result['skins'][$kidx]['fileFormat'] = strtolower($fileinfos['extension']);
					$result['skins'][$kidx]['fileMimeType'] = $this->_MIMES_TYPES[$result['skins'][$kidx]['fileFormat']];
					$result['skins'][$kidx]['displayName'] = $this->FileNameToDisplay($result['skins'][$kidx]['fileName']);
					$result['skins'][$kidx]['fileMTime'] = filemtime($result['sourcePath'].$fileinfos['basename']);
					$result['skins'][$kidx]['fileSize'] = filesize($result['sourcePath'].$fileinfos['basename']);
					
					//Recherche de l'aperu ; Jpg, Jpeg, GIF, ou PNG
					$result['skins'][$kidx]['Preview'] = array(); // create array even if there are no preview
					foreach($this->_ALLOWED_PREVIEW_EXTENSIONS as $_PREVIEW_EXTENSION)
						{
						if (file_exists($result['sourcePath'].$result['skins'][$kidx]['fileName'].".".$_PREVIEW_EXTENSION))
							{
							$result['skins'][$kidx]['Preview']['baseName'] = $result['skins'][$kidx]['fileName'].".".$_PREVIEW_EXTENSION;
							$result['skins'][$kidx]['Preview']['fileFormat'] = strtolower($_PREVIEW_EXTENSION);
							$result['skins'][$kidx]['Preview']['fileMimeType'] = $this->_MIMES_TYPES[$result['skins'][$kidx]['Preview']['fileFormat']];
							$result['skins'][$kidx]['Preview']['fileSize'] = filesize($result['sourcePath'].$result['skins'][$kidx]['Preview']['baseName']);
							break;
							}
						}
						
					// Open and load XML file
					if ($f = @fopen($result['sourcePath'].$result['skins'][$kidx]['fileName'].".xml", 'r'))
						{
						$xml_content = '';
						while (!feof($f))
							{
							$xml_content .= fgets($f, 4096);
							}
						fclose($f);
						
						// Parse SKIN info
						preg_match("'<skin(.*?)>'si", $xml_content, $out_skin);
						if (isset($out_skin[1]))
							{
							foreach($this->_XML_SKIN_ATTRIBUTES as $skinprop)
								{
								$temp = $this->my_preg_match("'$skinprop=[\'\"](.*?)[\'\"]'si", $out_skin[1]);
								if ($temp != '') $result['skins'][$kidx]['xml_'.$skinprop] = $temp; // Set only if not empty
								}
							}
						// Use xml_SkinName for displayName
						if (isset($result['skins'][$kidx]['xml_SkinName']))
							{
							$result['skins'][$kidx]['displayName'] = $result['skins'][$kidx]['xml_SkinName'];
							}
							
						// Search DEF sections for Messenger, Y!ME, or BT Communicator settings
						foreach($this->_XML_DEF_NAMES as $defname)
							{
							if (strpos($xml_content,'<def name="'.$defname.'">') !== FALSE) $result['skins'][$kidx]['xml_def_'.$defname] = TRUE;
							}
						}
						
					$i++;
					}
				else
					{
					// Type de fichier non autoris
					}
				}
			}
		closedir($rep);
		clearstatcache();
			
		if (($this->order_by == 'name') AND ($i > 0))
			{
			uasort($result['skins'],mYBS_CompareSkinsName);
			}
			
		if (($this->order_by == 'date') AND ($i > 0))
			{
			uasort($result['skins'],mYBS_CompareSkinsMTime);
			}
			
		if (($this->items_limit != 0) AND ($i > $this->items_limit))
			{
			$this->ArrayPop($result['skins'],$this->items_limit);
			}
			
		if ($this->_USE_SEVERAL_SOURCES)
			{
			$this->_STARTED_INDEX = $this->_STARTED_INDEX + count($result['skins']);
			}
		
		return $result;
		}
	
	// -------------------------------------------------------------------
	// Modification of preg_match(); return trimed field with index 1
	// from 'classic' preg_match() array output
	// -------------------------------------------------------------------
	function my_preg_match ($pattern, $subject) {
		// start regullar expression
		preg_match($pattern, $subject, $out);

		// if there is some result... process it and return it
		if(isset($out[1])) {
			// Process CDATA (if present)
			if ($this->CDATA == 'content') { // Get CDATA content (without CDATA tag)
				$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
			} elseif ($this->CDATA == 'strip') { // Strip CDATA
				$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
			}
			// Return result
			return trim($out[1]);
		} else {
		// if there is NO result, return empty string
			return '';
		}
	}
		
	function FileNameToDisplay($filename)
		{
		return mYBS_FileNameToDisplay($filename);
		}
		
	function CompareSkinsMTime($skinA,$skinB)
		{
		return mYBS_CompareSkinsMTime($skinA,$skinB);
		}
		
	function ArrayPop(&$arraytopop,$length=-1)
		{
		$arraytopop = array_slice($arraytopop, 0, $length);
		}
	}
	
// Public functions

function mYBS_GetInfos($SourcePath='./',$Lang='en',$Mode='html')
	{
	if (substr($SourcePath, -1) == '/')
		{
		$InfosFile['dirname'] = $SourcePath;
		}
	else
		{
		$InfosFile['dirname'] = $SourcePath.'/';
		}
	
	if ($Lang == 'fr')
		{
		$InfosFile['basename'] = 'info.fr';
		}
	else
		{
		$InfosFile['basename'] = 'info.en';
		}
		
	if ($Mode == 'html')
		{
		$InfosFile['extension'] = 'html';
		}
	else
		{
		$InfosFile['extension'] = 'txt';
		}
	
	if (file_exists($InfosFile['dirname'].$InfosFile['basename'].'.'.$InfosFile['extension']))
		{
		$InfosFileLines = file($InfosFile['dirname'].$InfosFile['basename'].'.'.$InfosFile['extension']);
		}
	else
		{
		$InfosFileLines[0] = '';
		}
		
	$InfosText = '';
	if (count($InfosFileLines) > 1)
		{
		while (list ($key, $val) = each ($InfosFileLines))
			{
			$InfosText .= '<p>'.$val.'</p>';
			}
		}
	else if (count($InfosFileLines) == 1)
		{
		if (strlen($InfosFileLines[0]) > 0)
			{
			$InfosText = '<p>'.$InfosFileLines[0].'</p>';
			}
		else
			{
			$InfosText = '';
			}
		}
	else if (strlen($InfosFileLines) > 0)
		{
		$InfosText = '<p>'.$InfosFileLines.'</p>';
		}
	else
		{
		$InfosText = '';
		}
	
	if ($Mode == 'text')
		{
		$InfosText = strip_tags($InfosText);
		}
		
	return $InfosText;
	}
	
// Private functions
	
function mYBS_CompareSkinsMTime($skinA,$skinB)
	{
	if ($skinA['fileMTime'] == $skinB['fileMTime']) return 0;
	return ($skinA['fileMTime'] > $skinB['fileMTime']) ? -1 : 1;
	}
	
function mYBS_CompareSkinsName($skinA,$skinB)
	{
	return strnatcasecmp($skinA['displayName'],$skinB['displayName']);
	}

function mYBS_FileNameToDisplay($filename)
	{
	$displayname = str_replace(array('-','_'), " ", $filename);
	$displaynamewords = explode(" ",$displayname);
	foreach ($displaynamewords as $key => $value)
		{
		$displaynamewords[$key] = ucfirst($value);
		}
	$displayname = implode(" ",$displaynamewords);
	
	return $displayname;
	}
	
function mYBS_ParseFileSize($filesize=0,$sizeformat='Ko',$sizedecimal=1,$decimalsep='.',$hundredsep=',')
	{
	if (($sizeformat=='Ko') OR ($sizeformat=='Mo'))
		{
		$filesize = $filesize / 1024;
		}
	if (($sizeformat=='Mo') OR ($sizeformat=='Go'))
		{
		$filesize = $filesize / 1024;
		}
	if ($sizeformat=='Go')
		{
		$filesize = $filesize / 1024;
		}
		
	$result = number_format($filesize,$sizedecimal,$decimalsep,$hundredsep);
	return $result;
	}
?>
